package com.allinpay.demo.trx;


import com.allinpay.demo.AIPGException;
import com.allinpay.demo.DemoConfig;
import com.allinpay.demo.util.HttpUtil;
import com.allinpay.demo.util.DemoUtil;
import com.allinpay.demo.xml.XmlParser;
import com.allinpay.demo.xstruct.common.AipgReq;
import com.allinpay.demo.xstruct.common.AipgRsp;
import com.allinpay.demo.xstruct.common.ReqHead;
import com.allinpay.demo.xstruct.common.RspHead;
import com.allinpay.demo.xstruct.trans.breq.TRANS_DETAIL;
import com.allinpay.demo.xstruct.trans.breq.TRANS_DETAILS;
import com.allinpay.demo.xstruct.trans.breq.TRANS_SUM;

/**
 * @Description 批量代收
 * @Author meixf@allinpay.com
 * @Date 2018年5月29日
 **/
public class Tranx100001 {
	
	public static void main(String args[]){
		ReqHead headreq = DemoUtil.makeReq("100001");
		
		TRANS_SUM trans_sum = new TRANS_SUM();
		trans_sum.setBUSINESS_CODE("19900");//必须使用业务人员提供的业务代码，否则返回“未开通业务类型”
		trans_sum.setTOTAL_ITEM("2") ;
		trans_sum.setTOTAL_SUM("4") ;
		trans_sum.setNOTIFYURL("http://127.0.0.1:8081/merapi/notifytest");
		
		TRANS_DETAILS details = new TRANS_DETAILS();
		
		TRANS_DETAIL trans_detail = new TRANS_DETAIL() ;
		trans_detail.setSN("1") ;
    	trans_detail.setACCOUNT_NAME("测试1") ;
 		trans_detail.setACCOUNT_PROP("0") ;
		trans_detail.setACCOUNT_NO("3228481200290317801") ;
		trans_detail.setBANK_CODE("0103") ;
		trans_detail.setAMOUNT("2") ;
		trans_detail.setCURRENCY("CNY");
		
		TRANS_DETAIL trans_detail2 = new TRANS_DETAIL() ;
		trans_detail2.setSN("2") ;
		trans_detail2.setACCOUNT_NAME("测试2") ;
		trans_detail2.setACCOUNT_NO("3228481200290318801") ;
		trans_detail2.setBANK_CODE("0103") ;
		trans_detail2.setAMOUNT("2") ;
		trans_detail2.setCURRENCY("CNY");
		
		details.addDetail(trans_detail) ;
		details.addDetail(trans_detail2);

		
		AipgReq req = new AipgReq();
		req.setREQ_HEAD(headreq);
		req.addTrx(trans_sum);
		req.addTrx(details);
		
		try{
			//step1 对象转xml
			String xml = XmlParser.toReqXml(req);
			//step2 加签
			String signedXml = DemoUtil.buildSignedXml(xml);
			//step3 发往通联
			String url = DemoConfig.prc_url + "?MERCHANT_ID="+headreq.getMERCHANT_ID()+"&REQ_SN="+headreq.getREQ_SN();
			System.out.println("============================请求报文============================");
			System.out.println(signedXml);
			String respText = HttpUtil.post(signedXml, url);
			System.out.println("============================响应报文============================");
			System.out.println(respText);
			//step4 验签
			if(!DemoUtil.verifyXml(respText)){
				System.out.println("====================================================>验签失败");
				return;
			}
			System.out.println("====================================================>验签成功");
			//step5 xml转对象
			AipgRsp rsp = XmlParser.toAipgRsp(respText);
			RspHead headrsp = rsp.getRSP_HEAD();
			System.out.println(headrsp.getRET_CODE());
			System.out.println(headrsp.getRET_MSG());
			if("0000".equals(headrsp.getRET_CODE())){
			}
		}catch(AIPGException e){
			e.printStackTrace();
		}
	}
	
}
