package com.allinpay.demo.trx;

import com.allinpay.demo.AIPGException;
import com.allinpay.demo.DemoConfig;
import com.allinpay.demo.util.DemoUtil;
import com.allinpay.demo.util.HttpUtil;
import com.allinpay.demo.xml.XmlParser;
import com.allinpay.demo.xstruct.common.AipgReq;
import com.allinpay.demo.xstruct.common.AipgRsp;
import com.allinpay.demo.xstruct.common.ReqHead;
import com.allinpay.demo.xstruct.common.RspHead;
import com.allinpay.demo.xstruct.trans.TRANS;

/**
 * @Description 单笔实时代收
 * @Author meixf@allinpay.com
 * @Date 2018年5月29日
 **/
public class Tranx100011 {

	public static void main(String[] args){
		
		ReqHead headreq = DemoUtil.makeReq("100011");
		
		TRANS trans = new TRANS();
		trans.setBUSINESS_CODE("19900");//必须使用业务人员提供的业务代码，否则返回“未开通业务类型”
		trans.setACCOUNT_NAME("银联");
		trans.setACCOUNT_NO("6224243000000006");
		trans.setACCOUNT_PROP("0");
		trans.setACCOUNT_TYPE("00");
		trans.setAMOUNT("1500");
		trans.setBANK_CODE("0104");
		trans.setCURRENCY("CNY");
		trans.setTEL("");
		trans.setCUST_USERID("410421197808247033");
		trans.setNOTIFYURL("http://127.0.0.1:8081/merapi/notifytest");
		
		AipgReq req = new AipgReq(headreq);
		req.addTrx(trans);
		try{
			//step1 对象转xml
			String xml = XmlParser.toReqXml(req);
			//step2 加签
			String signedXml = DemoUtil.buildSignedXml(xml);
			//step3 发往通联
			String url = DemoConfig.prc_url + "?MERCHANT_ID=" + headreq.getMERCHANT_ID() + "&REQ_SN=" + headreq.getREQ_SN();
			System.out.println("============================请求报文============================");
			System.out.println(signedXml);
			String respText = HttpUtil.post(signedXml, url);
			System.out.println("============================响应报文============================");
			System.out.println(respText);
			//step4 验签
			if(!DemoUtil.verifyXml(respText)){
				System.out.println("====================================================>验签失败");
				return;
			}
			System.out.println("====================================================>验签成功");
			//step5 xml转对象
			AipgRsp rsp = XmlParser.toAipgRsp(respText);
			RspHead headrsp = rsp.getRSP_HEAD();
			System.out.println(headrsp.getRET_CODE());
			System.out.println(headrsp.getRET_MSG());
			if("0000".equals(headrsp.getRET_CODE())){
			}
		}catch(AIPGException e){
			e.printStackTrace();
		}
	}
	
}
