package com.allinpay.demo.trx;

import com.allinpay.demo.AIPGException;
import com.allinpay.demo.DemoConfig;
import com.allinpay.demo.util.DemoUtil;
import com.allinpay.demo.util.HttpUtil;
import com.allinpay.demo.xml.XmlParser;
import com.allinpay.demo.xstruct.common.AipgReq;
import com.allinpay.demo.xstruct.common.AipgRsp;
import com.allinpay.demo.xstruct.common.ReqHead;
import com.allinpay.demo.xstruct.common.RspHead;
import com.allinpay.demo.xstruct.trans.qry.QTRANSREQ;

/**
 * @Description  通用退款
 * @Author meixf@allinpay.com
 * @Date 2018年5月29日
 **/
public class Tranx200004 {

	public static void main(String[] args){
		
		ReqHead headreq = DemoUtil.makeReq("200004");
		
		QTRANSREQ qreq = new QTRANSREQ();
		qreq.setSRC_BATCHID("630581000014813-0001543208714539");
		//qreq.setSRC_SN("1");
		//qreq.setTL_SEQ("100018083121157837");
		AipgReq req = new AipgReq(headreq);
		req.addTrx(qreq);
		try{
			//step1 对象转xml
			String xml = XmlParser.toReqXml(req);
			//step2 加签
			String signedXml = DemoUtil.buildSignedXml(xml);
			//step3 发往通联
			String url = DemoConfig.prc_url + "?MERCHANT_ID=" + headreq.getMERCHANT_ID() + "&REQ_SN=" + headreq.getREQ_SN();
			System.out.println("============================请求报文============================");
			System.out.println(signedXml);
			String respText = HttpUtil.post(signedXml, url);
			System.out.println("============================响应报文============================");
			System.out.println(respText);
			//step4 验签
			if(!DemoUtil.verifyXml(respText)){
				System.out.println("====================================================>验签失败");
				return;
			}
			System.out.println("====================================================>验签成功");
			//step5 xml转对象
			AipgRsp rsp = XmlParser.toAipgRsp(respText);
			RspHead headrsp = rsp.getRSP_HEAD();
			System.out.println(headrsp.getRET_CODE());
			System.out.println(headrsp.getRET_MSG());
		}catch(AIPGException e){
			e.printStackTrace();
		}
	}
}
