package com.allinpay.demo.xstruct.common;

import java.util.ArrayList;
import java.util.List;


public class AipgRsp {
	private RspHead HEAD;
	private List<Object> BODY;
	
	public RspHead getRSP_HEAD() {
		return HEAD;
	}
	public void setRSP_HEAD(RspHead rSP_HEAD) {
		HEAD = rSP_HEAD;
	}

	public void setTrx(Object obj){
		if(BODY == null){
			BODY = new ArrayList<Object>(1);
		}
		if(BODY.size() == 0){
			BODY.add(obj);
		}
		BODY.set(0, obj);
	}
	
	public Object getTrx(){
		if(BODY == null || BODY.size() == 0){
			return null;
		}
		return BODY.get(0);
	}
	
	public void addTrx(Object obj){
		if(BODY == null){
			BODY = new ArrayList<Object>(1);
		}
		BODY.add(obj);
	}
	
	public <T> T findTrx(Class<T> cls){
		if(BODY == null) return null;
		for(Object ox : BODY){
			if(cls.isInstance(ox)) return cls.cast(ox);
		}
		return null;
	}
	
	public static AipgRsp packRsp(AipgReq aipgReq , String retcode, String retmsg){
		return packRsp(aipgReq.getREQ_HEAD(), retcode, retmsg);
	}
	
	public static AipgRsp packRsp(ReqHead head, String retcode, String retmsg){
		AipgRsp aipgRsp = new AipgRsp();
		aipgRsp.setRSP_HEAD(RspHead.packRspHead(head, retcode, retmsg));
		return aipgRsp;
	}
}
